window.onload = function(){
    init();
}

var browser={
    versions:function(){
        var u = navigator.userAgent, app = navigator.appVersion;
        return {
            trident: u.indexOf('Trident') > -1, //IE内核
            presto: u.indexOf('Presto') > -1, //opera内核
            webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
            gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1,//火狐内核
            mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
            android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或者uc浏览器
            iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone或者QQHD浏览器
            iPad: u.indexOf('iPad') > -1, //是否iPad
            webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
            weixin: u.indexOf('MicroMessenger') > -1, //是否微信 （2015-01-22新增）
            qq: u.match(/\sQQ/i) == " qq" //是否QQ
        };
    }(),
    language:(navigator.browserLanguage || navigator.language).toLowerCase()
}
                           
var workspace = null;
function init(){
    if (browser.versions.mobile) {
        workspace = Blockly.inject('blocklyDiv',
        {/*grid:{spacing: 25,length: 3,colour: '#ccc',snap: true},*/
        zoom:{controls:true,
                 wheel:true,
            startScale:0.9,
              maxScale:1.5,
              minScale:0.5,
            scaleSpeed:1.1},
        media: '../blockly/media/',
        toolbox: document.getElementById('toolbox'),
        trashcan:true,
        sounds:true,
        /*horizontalLayout:true*/});
    } else {
        workspace = Blockly.inject('blocklyDiv',
        {/*grid:{spacing: 25,length: 3,colour: '#ccc',snap: true},*/
        zoom:{controls:true,
                 wheel:true,
            startScale:1.2,
              maxScale:2.5,
              minScale:0.5,
            scaleSpeed:1.1},
        media: '../blockly/media/',
        toolbox: document.getElementById('toolbox'),
        trashcan:true,
        sounds:true});
    }
    workspace.addChangeListener(Blockly.Events.disableOrphans);
    addBegin();
    changeDefaultStyle();
}
function changeDefaultStyle(){
    var btn_back = document.getElementById('back');
    btn_back.onclick=function(){
        back();
    };
                           
    var blocklyToolbox = document.getElementsByClassName('blocklyToolboxDiv')[0];
    if (browser.versions.iPhone || browser.versions.android)
    {
        blocklyToolbox.style.width = '25.3vh';
    }
    else
    {
        blocklyToolbox.style.width = '24.0vh';
    }
    btn_back.style.width = blocklyToolbox.style.width;
}

function back() {
    if(workspace){
        window.jsCallJavaInterface.onBack();
    }
}
                           
function showBlockCode() {
    if(workspace){
         var code = Blockly.Lua.workspaceToCode(workspace);
         window.jsCallJavaInterface.onGenerationCode(code);
    }
}
function startRunCode() {
    if(workspace){
        var code = Blockly.Lua.workspaceToCode(workspace);
        window.jsCallJavaInterface.onRunCode(code);
    }
}
function setWorkspaceBase64(b64) {
    if(workspace){
        var xml_text = decodeURIComponent(atob(b64));
        var xml = Blockly.Xml.textToDom(xml_text);
        workspace.clear();
        Blockly.Xml.domToWorkspace(xml, workspace);
        workspace.clearUndo();
    }
}
function getWorkspaceBase64(){
    if(workspace){
        var xml = Blockly.Xml.workspaceToDom(workspace);
        var xml_text = Blockly.Xml.domToText(xml);
        var b64 = btoa(encodeURIComponent(xml_text));
        window.jsCallJavaInterface.onSaveCode(b64);
    }
}


// 工作区的撤销、重做
function workspaceUndo(redo) {
    if (workspace) {
        workspace.undo(redo);
    }
}

function loadWorkspace(xml){
    if(xml) {
        setWorkspaceBase64(xml);
    }
}

//添加头部开始块，并使未与头部块连接的块变得无效
function addBegin(){
     var block_xml_code = "<xml><block type=\"begin\" id=\"I7rX8RCmeBT.ePwHYv[#\" deletable=\"false\" x=\"10\" y=\"10\"></block></xml>";
    //添加头部开始块
    Blockly.Xml.domToWorkspace(Blockly.Xml.textToDom(block_xml_code), workspace);
    if (workspace) {
        workspace.clearUndo();
    }
}

