window.onload = function(){
    init();
}

var browser={
    versions:function(){
        var u = navigator.userAgent, app = navigator.appVersion;
        return {
            trident: u.indexOf('Trident') > -1, //IE内核
            presto: u.indexOf('Presto') > -1, //opera内核
            webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
            gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1,//火狐内核
            mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
            android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或者uc浏览器
            iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone或者QQHD浏览器
            iPad: u.indexOf('iPad') > -1, //是否iPad
            webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
            weixin: u.indexOf('MicroMessenger') > -1, //是否微信 （2015-01-22新增）
            qq: u.match(/\sQQ/i) == " qq" //是否QQ
        };
    }(),
    language:(navigator.browserLanguage || navigator.language).toLowerCase()
}
                           
var workspace = null;
function init(){
    if (browser.versions.mobile) {
        workspace = Blockly.inject('blocklyDiv',
        {/*grid:{spacing: 25,length: 3,colour: '#ccc',snap: true},*/
        zoom:{controls:false,
                 wheel:false,
            startScale:0.9,
            maxScale:1.5,
            minScale:0.5,
            scaleSpeed:1.1},
        media: '../blockly/media/',
        toolbox: document.getElementById('toolbox'),
        trashcan:false,
        sounds:true,
        /*horizontalLayout:true*/});
    } else {
        workspace = Blockly.inject('blocklyDiv',
        {/*grid:{spacing: 25,length: 3,colour: '#ccc',snap: true},*/
        zoom:{controls:false,
                 wheel:false,
            startScale:1.2,
            maxScale:2.5,
            minScale:0.5,
            scaleSpeed:1.1},
        media: '../blockly/media/',
        toolbox: document.getElementById('toolbox'),
        trashcan:false,
        sounds:true});
    }
    workspace.addChangeListener(Blockly.Events.disableOrphans);
    changeDefaultStyle();
}
function changeDefaultStyle(){
	var blocklyToolbox = document.getElementsByClassName('blocklyToolboxDiv')[0];
	blocklyToolbox.style.backgroundColor = '#fff';
	blocklyToolbox.style.borderRight='1px solid #ddd';
    blocklyToolbox.style.width='24.22vh';
                           
    var blocklyTreeRoot = document.getElementById(':0');
    blocklyTreeRoot.style.paddingTop = '15.5vh';
                           
	var blocklyFlyoutBackground = document.getElementsByClassName('blocklyFlyoutBackground')[0];
    blocklyFlyoutBackground.style.fill = '#eee';
	blocklyFlyoutBackground.style.fillOpacity = '0.8';
                           
    var btn_back = document.getElementById('back');
    btn_back.onclick=function(){
        back();
    };
}

function back() {
    if(workspace){
        window.hintInterface.onHintBack();
    }
}
                           
function showBlockCode() {
    if(workspace){
        var code = Blockly.Lua.workspaceToCode(workspace);
        window.webkit.messageHandlers.CodeGen.postMessage(code);
    }
}
function startRunCode() {
    if(workspace){
        var code = Blockly.Lua.workspaceToCode(workspace);
        window.webkit.messageHandlers.CodeRun.postMessage(code);
    }
}
function setWorkspaceBase64(b64) {
    if(workspace){
        var xml_text = decodeURIComponent(atob(b64));
        var xml = Blockly.Xml.textToDom(xml_text);
        Blockly.Xml.domToWorkspace(xml, workspace);
        workspace.clearUndo();
    }
}
function getWorkspaceBase64(){
    if(workspace){
        var xml = Blockly.Xml.workspaceToDom(workspace);
        var xml_text = Blockly.Xml.domToText(xml);
        var b64 = btoa(encodeURIComponent(xml_text));
        window.webkit.messageHandlers.GetWorkspaceXmlBase64.postMessage(b64);
    }
}

function loadWorkspace(xml){
    if(xml) {
        setWorkspaceBase64(xml);
    }
}