
Blockly.Lua['sleep'] = function(block) {
  var number_time = block.getFieldValue('time');
  // TODO: Assemble Lua into code variable.
  return 'Tudao_sleep('+number_time+')\n';
};

// 电机控制
Blockly.Lua['motoraction'] = function(block) {
    var dropdown_port = block.getFieldValue('port');
    var dropdown_direction = block.getFieldValue('direction');
    var number_speed = Blockly.Lua.valueToCode(block, 'speed', Blockly.Lua.ORDER_ATOMIC);
    // TODO: Assemble Lua into code variable.
    return 'Tudao_motorAction(\''+dropdown_port+'\','+number_speed+',\''+dropdown_direction+'\')\n';
};

// 电机停止
Blockly.Lua['motorstop'] = function(block) {
    var dropdown_port = block.getFieldValue('port');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_motorStop(\''+dropdown_port+'\')\n';
};

// 读取陀螺仪的X或Y的值
Blockly.Lua['gyro'] = function(block) {
    var dropdown_gyro_xy = block.getFieldValue('GYRO_XY');
    // TODO: Assemble Lua into code variable.
    return ['Tudao_getGyroValue(\''+dropdown_gyro_xy+'\')', Blockly.Lua.ORDER_NONE];
};

// 读取超声波的值
Blockly.Lua['ultrasound'] = function(block) {
    // TODO: Assemble Lua into code variable.
    return ['Tudao_getUltrasoundValue()', Blockly.Lua.ORDER_NONE];
};

// 音效
Blockly.Lua['sound'] = function(block) {
    var dropdown_sound = block.getFieldValue('sound');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_playSound(\''+dropdown_sound+'\')\n';
};

// 背景音乐
Blockly.Lua['bgmusic'] = function(block) {
    var dropdown_bgmusic = block.getFieldValue('bgMusic');
    var statements_statements = Blockly.Lua.statementToCode(block, 'statements');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_bgmStart(\''+dropdown_bgmusic+'\')\n'+statements_statements+'Tudao_bgmEnd()\n';
};

// 播放音乐
Blockly.Lua['bgstart'] = function(block) {
    var dropdown_bgmusic = block.getFieldValue('bgMusic');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_bgmStart(\''+dropdown_bgmusic+'\')\n';
};

// 停止播放
Blockly.Lua['bgend'] = function(block) {
    // TODO: Assemble Lua into code variable.
    return 'Tudao_bgmEnd()\n';
};

// 麦克风
Blockly.Lua['mic'] = function(block) {
    // TODO: Assemble Lua into code variable.
    return ['Tudao_getMicValue()', Blockly.Lua.ORDER_NONE];
};

// led控制
Blockly.Lua['ledcolor'] = function(block) {
    var dropdown_led = block.getFieldValue('led');
    var dropdown_color = block.getFieldValue('color');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_led(\''+dropdown_led+'\',\''+dropdown_color+'\')\n';
};

// 避障
Blockly.Lua['tracking'] = function(block) {
    var dropdown_left = block.getFieldValue('left');
    var dropdown_right = block.getFieldValue('right');
    // TODO: Assemble Lua into code variable.
    var code = 'Tudao_tracking(\''+dropdown_left+'\',\''+dropdown_right+'\')';
    // TODO: Change ORDER_NONE to the correct strength.
    return [code, Blockly.Lua.ORDER_NONE];
};

// 录音
Blockly.Lua['recording'] = function(block) {
    var text_edit = block.getFieldValue('EDIT');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_recording(\''+text_edit+'\')\n';
};

// 程序入口，开始
Blockly.Lua['begin'] = function(block) {
    // TODO: Assemble Lua into code variable.
    //    return 'Tudao_begin();\n';
    return '';
};

// 视频
Blockly.Lua['playmovie'] = function(block) {
    var text_movie = block.getFieldValue('MOVIE');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_playMovie(\''+text_movie+'\')\n';
};

// if-else
Blockly.Lua['if_else'] = function(block) {
    var value_condition = Blockly.Lua.valueToCode(block, 'CONDITION', Blockly.Lua.ORDER_ATOMIC);
    value_condition = value_condition?value_condition:false;
    var statements_true = Blockly.Lua.statementToCode(block, 'TRUE');
    var statements_false = Blockly.Lua.statementToCode(block, 'FALSE');
    // TODO: Assemble Lua into code variable.
    return 'if '+value_condition+' then\n'+statements_true+'else\n'+statements_false+'end\n';
};

// if-elseif-else
Blockly.Lua['if_elseif_else'] = function(block) {
    var value_condition1 = Blockly.Lua.valueToCode(block, 'CONDITION1', Blockly.Lua.ORDER_ATOMIC);
    value_condition1 = value_condition1?value_condition1:false;
    var statements_true1 = Blockly.Lua.statementToCode(block, 'TRUE1');
    var value_condition2 = Blockly.Lua.valueToCode(block, 'CONDITION2', Blockly.Lua.ORDER_ATOMIC);
    value_condition2 = value_condition2?value_condition2:false;
    var statements_true2 = Blockly.Lua.statementToCode(block, 'TRUE2');
    var statements_false = Blockly.Lua.statementToCode(block, 'FALSE');
    // TODO: Assemble Lua into code variable.
    return 'if '+value_condition1+' then\n'+statements_true1+'elseif '+value_condition2+' then\n'+statements_true2+'else\n'+statements_false+'end\n';
};

// 文字转语音
Blockly.Lua['say'] = function(block) {
    var text_text = block.getFieldValue('TEXT');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_say(\''+text_text+'\')\n';
};

// 7音阶
Blockly.Lua['gamut'] = function(block) {
    var dropdown_gamut = block.getFieldValue('GAMUT');
    // TODO: Assemble Lua into code variable.
    return 'Tudao_gamut(\''+dropdown_gamut+'\')\n';
};

// 距离传感器
Blockly.Lua['distance_sensor'] = function(block) {
    var dropdown_index = block.getFieldValue('index');
    // TODO: Assemble Lua into code variable.
    var code = 'Tudao_distanceSensor(\''+dropdown_index+'\')';
    // TODO: Change ORDER_NONE to the correct strength.
    return [code, Blockly.Lua.ORDER_NONE];
};

// 显示文本
Blockly.Lua['show_text'] = function(block) {
    var value_content = Blockly.Lua.valueToCode(block, 'CONTENT', Blockly.Lua.ORDER_ATOMIC);
    if(value_content.indexOf("“") == -1)
    {
        return 'Tudao_showText('+value_content+')\n';
    }
    // TODO: Assemble Lua into code variable.
    return 'Tudao_showText(\''+value_content+'\')\n';
};

// 文本
Blockly.Lua['content'] = function(block) {
    var text_content = block.getFieldValue('CONTENT');
    // TODO: Change ORDER_NONE to the correct strength.
    return [text_content, Blockly.Lua.code];
};

// 显示比分
Blockly.Lua['show_score'] = function(block) {
    var value_num1 = Blockly.Lua.valueToCode(block, 'NUM1', Blockly.Lua.ORDER_ATOMIC);
    var value_num2 = Blockly.Lua.valueToCode(block, 'NUM2', Blockly.Lua.ORDER_ATOMIC);
    // TODO: Assemble Lua into code variable.
    return 'Tudao_showScore('+value_num1+','+value_num2+')\n';
};
